#ifndef _OV7670_FUNCTIONS_H_
	#define _OV7670_FUNCTIONS_H_

	#include"I2CMASTER.h"
	#include "ov7670config.h"
	
	#define _OV_CONTROLPORT_DIR_ 	FIO0DIR2	
	#define _OV_CONTROLPORT_SET_ 	FIO0SET2	
	#define _OV_CONTROLPORT_CLR_ 	FIO0CLR2

	#define OV_RST					0
	#define OV_PWDN   				1


	#define OV_RST_LOW				_OV_CONTROLPORT_CLR_ = (1 << OV_RST)
	#define OV_RST_HIGH				_OV_CONTROLPORT_SET_ = (1 << OV_RST)
	#define OV_PWDN_LOW				_OV_CONTROLPORT_CLR_ = (1 << OV_PWDN)
	#define OV_PWDN_HIGH			_OV_CONTROLPORT_SET_ = (1 << OV_PWDN)
	
	#define HIGH					1
	#define LOW						0

	#define false					0
	#define true					1

	#define data_write				0
	#define data_read				1

	#define OV_ADD					0x21	
	
	#define OV_POWER_DOWN			_OV_CONTROLPORT_SET_ = (1 << OV_PWDN)
	#define OV_POWER_UP				_OV_CONTROLPORT_CLR_ = (1 << OV_PWDN)
	
	#define EXT_INT_EN				VICIntEnable=(1<<14)
	#define EXT_INT_DIS				VICIntEnClr=(1<<14)		



unsigned char jj=0;

__irq void extint_isr(void)
{
	TFTLCD_CS_LOW;
	EXT_INT_DIS;

	
	EXTINT |=1;
	VICVectAddr=0x00000000;
}

unsigned char wrOV7670Reg(unsigned char regID, unsigned char regDat)
{
	unsigned char tem[2];
	tem[0]=regID;
	tem[1]=regDat;
	return(i2c_tranceive_data(OV_ADD,data_write,2,tem));
}

unsigned char rdOV7670Reg(unsigned char regID, unsigned char *regDat)
{	
	if(0==i2c_tranceive_data(OV_ADD,data_write,1,&regID)) return(0);
	return(i2c_tranceive_data(OV_ADD,data_read,1,regDat));
}

void OV7670_config_window(unsigned int startx,unsigned int starty,unsigned int width, unsigned int height)
{
	unsigned int endx;
	unsigned int endy;// "v*2"??
	unsigned char temp_reg1, temp_reg2;
	unsigned char temp;
	
	endx=(startx+width);
	endy=(starty+height);// "v*2"??
	rdOV7670Reg(0x03, &temp_reg1 );
	temp_reg1 &= 0xf0;
	rdOV7670Reg(0x32, &temp_reg2 );
	temp_reg2 &= 0xc0;
	
	// Horizontal
	temp = temp_reg2|((endx&0x7)<<3)|(startx&0x7);
	wrOV7670Reg(0x32, temp );
	temp = (startx&0x7F8)>>3;
	wrOV7670Reg(0x17, temp );
	temp = (endx&0x7F8)>>3;
	wrOV7670Reg(0x18, temp );
	
	// Vertical
	temp = temp_reg1|((endy&0x3)<<2)|(starty&0x3);
	wrOV7670Reg(0x03, temp );
	temp = starty>>2;
	wrOV7670Reg(0x19, temp );
	temp = endy>>2;
	wrOV7670Reg(0x1A, temp );
}

unsigned char OV7670_init(void)
{

	unsigned int i=0;

	_OV_CONTROLPORT_DIR_ |= (1 << OV_RST)|(1 << OV_PWDN);

	i2c0_init();
	OV_RST_HIGH;
	OV_POWER_UP;				//Normall mode

	PINSEL4 |= (1<<20);			//pin function select

	EXTINT |=1;
	EXTMODE |=1;
	//EXTPOLAR |=1;
	VICVectAddr14=(unsigned long)extint_isr;

	
	if(0==wrOV7670Reg(0x12, 0x80)) //Reset SCCB
	{
		return 0 ;	
	}
	
	wait_ms(10);
	
	for(i=0;i<CHANGE_REG_NUM;i++)
	{
		if(0==wrOV7670Reg(cam_reg[i][0],cam_reg[i][1]))
		{
			return 0;
		}
	}
	 OV7670_config_window(272,12,320,240);// set 240*320		 //272	,153
	
	return 1; //ok
}

#endif 
